.486
.model flat, stdcall
option casemap: none

; API functions
; ------------------------------------------------------------------------------
include  \masm32\include\windows.inc
include  \masm32\include\user32.inc
include  \masm32\include\kernel32.inc
include  \masm32\include\comctl32.inc
include  \masm32\include\masm32.inc

includelib  \masm32\lib\user32.lib
includelib  \masm32\lib\kernel32.lib
includelib  \masm32\lib\comctl32.lib
includelib  \masm32\lib\masm32.lib

include   \masm32\macros\macros.asm  ; <- needed to invoke "m2m" macro
; ------------------------------------------------------------------------------

; Prototype 
; ------------------------------------------------------------------------------
DialogProc PROTO : HWND, : UINT, : WPARAM, : LPARAM

.const

; Resource ids
; ------------------------------------------------------------------------------
IDD_DLG1  	  equ 101
IDI_ICON      equ 200
; Required data

.data
szTitle       TCHAR "Icon pull down menu", 0
szMsgTitle		db	"My Title", 0
szMsgText		db	"Pull down menu from the Icon", 13, 10, 13, 10
				db	"Version 1.0", 13, 10, 13, 10
				db	"This is an example of a -", 13, 10
				db	"Pull down menu from the Icon", 13, 10
				db	"With a Messaage Box !",0

szMenuName		db	"&Test Window ...", 0
.data?

hInstance HINSTANCE ?
hIcon     HICON     ?
mbp		  MSGBOXPARAMS	<>
.code

start:
INVOKE GetModuleHandle, NULL
mov hInstance, eax

INVOKE LoadIcon, eax, IDI_ICON 
mov hIcon, eax
INVOKE InitCommonControls
; ---------------------------------------------
;   Call the dialog box stored in resource file
; ---------------------------------------------
INVOKE DialogBoxParam, hInstance, IDD_DLG1 , NULL, ADDR DialogProc, 0
INVOKE ExitProcess, 0


; Dialog procedure
; ------------------------------------------------------------------------------
DialogProc proc hWnd: HWND, uMsg: UINT, wParam: WPARAM, lParam: LPARAM

 .IF uMsg == WM_INITDIALOG
 
  INVOKE SetWindowText, hWnd, addr szTitle 
  INVOKE SendMessage, hWnd, WM_SETICON,ICON_SMALL, hIcon
  INVOKE	GetSystemMenu, hWnd, 0
		push	OFFSET szMenuName
		push	10
		push	MFT_STRING
		push	eax
		INVOKE	AppendMenu, eax, MFT_SEPARATOR, 0, 0
		CALL	AppendMenu

    .ELSEIF uMsg == WM_COMMAND
    .ELSEIF uMsg == WM_SYSCOMMAND && wParam ==10
		mov	[mbp.cbSize], sizeof mbp
		mov	[mbp.lpszText], OFFSET szMsgText
		m2m	[mbp.hInstance], hInstance ; <- Use "m2m" to call macro instead of "mov"
		mov	[mbp.lpszCaption], OFFSET szMsgTitle
		mov	[mbp.dwStyle], MB_USERICON ; <- This makes room for an icon
		mov	[mbp.lpszIcon],200

		INVOKE	MessageBoxIndirect, ADDR mbp
      .ELSEIF uMsg == WM_CLOSE
    INVOKE EndDialog, hWnd, 0
 .ENDIF

    xor eax,eax
  ret
DialogProc endp

end start